#/usr/bin/env python
# -*- coding: utf-8 -*-
'''
Created on 12 nov. 2011

@author: Julien Eychenne
'''

from libdcn import *

#===============================================================================
# Load lexicon
#===============================================================================

training_path = '/home/julien/Devel/dcn/data/cmlf_train.txt'
valid_path = '/home/julien/Devel/dcn/data/cmlf_valid.txt'
test_path = '/home/julien/Devel/dcn/data/cmlf_test.txt'

training_lex = load_lexicon(training_path)
valid_lex = load_lexicon(valid_path)
test_lex = load_lexicon(test_path)

#===============================================================================
# Sonority dictionary
#===============================================================================

sonority_pos = {
    'p': 1, 't':1, 'k':1,
    'b': 2, 'd':2, 'g':2,
    'f':3, 's':3, u'ʃ':3, 
    'v':4, 'z':4, u'ʒ':4,
    'm':5, 'n':5, u'ɲ':5, u'ŋ':5,
    'r':6, 'l':6,
    'w':7, u'ɥ':7, 'j':7,
    u'ɴ':7,  
    u'ə':8,
    'i':9, 'y':9, 'u':9,
    'e':11, u'ø':11, 'o':11, u'ɛ':11, u'œ':11, u'ɔ':11, '*':11, '6':11,
    'a':13       
}

sonority_neg = {
    'p': -7, 't':-7, 'k':-7,
    'b': -6, 'd':-6, 'g':-6,
    'f':-5, 's':-5, u'ʃ':-5, 
    'v':-4, 'z':-4, u'ʒ':-4,
    'm':-3, 'n':-3, u'ɲ':-3, u'ŋ':-3,
    'r':-2, 'l':-2,
    'w':-1, u'ɥ':-1, 'j':-1,
    u'ɴ':-1,  
    u'ə':0,
    'i':1, 'y':1, 'u':1,
    'e':3, u'ø':3, 'o':3, u'ɛ':3, u'œ':3, u'ɔ':3, '*':3, '6':3,
    'a':5       
}    
sonority = sonority_pos
#sonority = assign_random_sonority(sonority.keys())

choice = 5

if choice == 0:
    run_ssp_baseline(valid_lex, sonority)
elif choice == 1:
    run_once(training_lex, valid_lex, sonority, True)
elif choice == 2:
    run_multiple(training_lex, valid_lex, sonority, 100, 95.)
    
    
#Alpha: 0.210659
#Beta: -0.015455
#*************************
avg_bias_son = {
    '*': 11.006086,
    '6': 11.202947,
    'a': 14.326968,
    'b': 1.497950,
    'd': 1.240329,
    'e': 12.145364,
    'f': 2.416922,
    'g': 1.924453,
    'i': 10.327411,
    'j': 7.047871,
    'k': 1.727636,
    'l': 5.242668,
    'm': 3.455169,
    'n': 3.991833,
    'o': 11.325888,
    'p': 0.537025,
    'r': 5.480153,
    's': 1.271067,
    't': -0.396099,
    'u': 9.589393,
    'v': 3.062294,
    'w': 7.745400,
    'y': 9.413459,
    'z': 3.470413,
    u'ø': 11.114318,
    u'ŋ': 5.000000,
    u'œ': 11.198046,
    u'ɔ': 12.480407,
    u'ə': 10.410074,
    u'ɛ': 12.258309,
    u'ɥ': 7.063907,
    u'ɲ': 4.899749,
    u'ɴ': 6.363305,
    u'ʃ': 2.793859,
    u'ʒ': 3.694399,
}



#Alpha: 0.204843
#Beta: -0.020909

unbiased_avg_son = {
    '*': 1.691517,
    '6': 2.272011,
    'a': 4.578038,
    'b': -1.145252,
    'd': -1.366802,
    'e': 3.615235,
    'f': -0.805171,
    'g': -0.591228,
    'i': 3.330564,
    'j': 1.392594,
    'k': -0.870774,
    'l': 0.601845,
    'm': -1.024946,
    'n': -0.572901,
    'o': 2.713220,
    'p': -1.504097,
    'r': 0.719642,
    's': -1.284666,
    't': -2.131087,
    'u': 2.666448,
    'v': -0.855120,
    'w': 1.981304,
    'y': 2.447707,
    'z': -0.313522,
    u'ø': 2.046284,
    u'ŋ': 1.000000,
    u'œ': 2.438328,
    u'ɔ': 3.989064,
    u'ə': 3.763651,
    u'ɛ': 3.844527,
    u'ɥ': 1.505065,
    u'ɲ': 0.703504,
    u'ɴ': 1.116177,
    u'ʃ': -0.012035,
    u'ʒ': -0.058640,
}


best_model = DcnModel(0.204843,-0.020909, unbiased_avg_son)
print "Training set:"
generate_model_report(best_model, training_lex, 'avg_unbiased_training.txt')
print "Validation set:"
generate_model_report(best_model, valid_lex, 'avg_unbiased_valid.txt')
print "Test set:"
generate_model_report(best_model, test_lex, 'avg_unbiased_test.txt')

